using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using MySql.Data.MySqlClient;
using fatd_faturamento.ENTIDADE;
using fatd_faturamento.DAL.Conexao;

namespace fatd_faturamento.DAL.Persistencia
{
    public class dalCaduniCronograma
    {

        string vFILTER = null;
        string vINNERJOIN = null;
        string vAND = null;
        string vORDERBY = null;

        #region Métodos

        public DataTable Select(entidadeCaduniCronograma objCaduniCronograma)
        {
            DataTable dt = null;
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;


            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {

                    vFILTER = vFILTER + "ID, ";
                    vFILTER = vFILTER + "ANO, ";
                    vFILTER = vFILTER + "ID_CADUNI_PROCESSOS, ";
                    vFILTER = vFILTER + "DESCRICAO_CADUNI_PROCESSOS, ";
                    vFILTER = vFILTER + "ID_CADUNI_GRUPOS, ";
                    vFILTER = vFILTER + "DESCRICAO_CADUNI_GRUPOS, ";
                    vFILTER = vFILTER + "DT_ANOMES_INICIO_MENSAGEM, ";
                    vFILTER = vFILTER + "DT_LIMITE_ATUALIZACAO, ";
                    vFILTER = vFILTER + "DT_ANOMES_CANCELAMENTO, ";
                    vFILTER = vFILTER + "ATIVO ";

                    vINNERJOIN = " ";

                    vORDERBY = " ";

                    vAND = vAND + "AND ANO = ?ANO ";
                   vAND = vAND + "AND ID_CADUNI_GRUPOS = ?ID_CADUNI_GRUPOS ";
                    vAND = vAND + "AND DT_ANOMES_INICIO_MENSAGEM = ?DT_ANOMES_INICIO_MENSAGEM ";


                    cmd = new MySqlCommand(this.QuerySelect);

                    cmd.Parameters.AddWithValue("?ANO", objCaduniCronograma.ANO);
                    cmd.Parameters.AddWithValue("?ID_CADUNI_GRUPOS", objCaduniCronograma.ID_CADUNI_GRUPOS);
                    cmd.Parameters.AddWithValue("?DT_ANOMES_INICIO_MENSAGEM", objCaduniCronograma.DT_ANOMES_INICIO_MENSAGEM);

                    dt = objGerenciadorTransacao.GetDataTable(cmd);
                }

                return dt;
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }


        #endregion

        #region " Comandos SQL "

        StringBuilder sb = new StringBuilder();


        protected string QueryInsert
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("INSERT INTO  ");
                this.sb.AppendLine("CADUNI_CRONOGRAMA SET  ");
                this.sb.AppendLine(vFILTER);

                return sb.ToString();
            }
        }

        protected string QueryUpdate
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("UPDATE  ");
                this.sb.AppendLine("CADUNI_CRONOGRAMA SET  ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);

                return sb.ToString();
            }
        }

        protected string QueryDelete
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("DELETE FROM CADUNI_CRONOGRAMA ");
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }

        protected string QuerySelect
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("SELECT ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("FROM ");
                this.sb.AppendLine("CADUNI_CRONOGRAMA  ");
                this.sb.AppendLine(vINNERJOIN);
                this.sb.AppendLine("WHERE 1 = 1  ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }

        #endregion

    }
}
